import signInSuccComp from './signInSuccess.vue'
import { mergeOptions } from './plugin_helper'
import objectAssign from 'object-assign'

let $vm
let watcher

const plugin = {
  install (vue, pluginOptions = {}) {
    const SignInSucc = vue.extend(signInSuccComp)

    if (!$vm) {
      $vm = new SignInSucc({
        el: document.createElement('div')
      })
      document.body.appendChild($vm.$el)
    }

    const signInSucc = {
      show (options = {}) {
        watcher && watcher()
        if (typeof options === 'string') {
          mergeOptions($vm, objectAssign({}, pluginOptions, {text: options}))
        } else if (typeof options === 'object') {
          mergeOptions($vm, objectAssign({}, pluginOptions, options))
        }
        if (typeof options === 'object' && options.clickSure) {
            watcher = $vm.$watch('showDialogStyle', (val) => {
                options.clickSure && options.clickSure($vm)
            })
        }
        $vm.showDialogStyle = true
      },
      hide () {
        $vm.showDialogStyle = false
      }
    }
    // all Vux's plugins are included in this.$vux
    if (!vue.$vux) {
      vue.$vux = {
        signInSucc
      }
    } else {
      vue.$vux.signInSucc = signInSucc
    }

    vue.mixin({
      created: function () {
        this.$vux = vue.$vux
      }
    })
  }
}

export default plugin
export const install = plugin.install